0.1.1 - 26.08.08
-----------------------
Blub:
- restore compatibility with python v2.4

0.1.0 - 24.08.08
-----------------------
Blub:
- ported RawServer.py again from the original Rufus 0.6.9, the ported version is now much closer to the original version
- removed SamWrapper, because of the new port of RawServer the wrapper is no longer necessary
- added SamListener, responsible for accepting inbound connections and handing them to the appropriate RawServer instance
- updated PySamLib from v0.0.4 to v0.1.0

0.0.5 - 17.08.08
-----------------------
Blub:
- reduced slice request size to 16kb from 64kb, thats a more sensible size for i2p
- increased pipelining to 8 requests; with a request size of 16kb this matches i2psnarks limit for outstanding requests
- settings and state data are now always stored inside the application directory, not inside some user directories (that was already the case on windows)
- replaced the old sam library with a new one which supports version 2.0 of the sam bridge protocol, added a wrapper class to ease the replacement 
- because of the new sam library the "concurrent connection attempts" setting is now meaningless and got removed
- resized options dialog

0.0.4 - 28.11.05
-----------------------
*Rawn -   Added all other new features/bugfixes out of the new Rufus 0.6.9 release (like for example Fast-Resume), if defnax hadn't added them already. One warning about the "searchpanel": It will search for things by using the default-browser, so if thats not the one, which uses I2P, on your system, _don't_ use the search-thingy! I will add a warning message to the panel in the next version...
*Rawn -   Changed the scrape behaviour: It will now update the available Leechers/seeds numbers for a torrent every 20 minutes, instead of only once at the start and it will use all available trackers for this
*Rawn -   Added some code to let I2PRufus use the information, on how many available Leechers/Seeds there are, which is returned on normal announce-requests to the tracker. Sadly postmans tracker doesn't supply that information (it's optional), so this is currently not of much use.
*Rawn -   Made I2PRufus compatible with the Azureus Tracker. Sadly the bigger half of the fix isn't needed anymore since I2P-0.6.1.6 came out... -_-
*Rawn -   Changed or added some other small things, like config-defaults, the displayed name of some clients and other such stuff.
*defnax - Changend systray tooltip from 0:Dn - 0:Up to 0KB/s:Dn - 0KB/s:Up
*defnax - Added a new menu item called 'Torrents' which gives menu access to stopping, resuming and removing of torrents
*defnax - Added Open Torrent for Seeding in "File"
*defnax - Changed the tray icon when not minimised to tray (when using the 'fixed tray icon' setting) to red the 'R'
*defnax - Added Peers, Leechers and Seeds to web interface
*defnax - Added new 'connecting' and 'connected' states (with new icon) to represent the states before a download starts


0.0.3 - 14.11.05
-----------------------
*defnax - added an identifier for I2PSnark, allowing I2PRufus to detect that client correctly
*defnax - Renamed "rufus.py" to I2PRufus.py
*defnax - Changend in "winsetup.py" the main file to I2PRufus.py
*defnax - Edited "rufus.nsi": changend Rufus to I2PRufus and the folders Rufus to I2PRufus and the correct version number
*defnax - Changend in "install" the folders dir to I2PRufus and the name to I2PRufus
*Rawn  - Rewrote a class and added another, allowing Rufus to use one local destination/one SAM session for all torrents
*Rawn  - Made it possible for I2PRufus, using the above, to survive router restarts.
*Rawn  - Made a lot things about the tunnels configurable
*Rawn  - Most classes of I2PRufus don't just print log messages to stdout anymore, but correctly log and print them one after another

0.0.2  - 09.11.05
-----------------------
*Rawn - I2PRufus now correctly uses one instance of ducks client for every torrent and uses a different sessionname for each -> multiple torrents work now
*Rawn - Disabled the logging to a file in ducks client, to prevent each instance from creating it's own logfile
*Rawn - Removed everything, that had something to do with version-checking, including any config-dialog/parameter
*Rawn - Removed the reverseDNS future and the country-flags future, including any config-dialog/parameter
*Rawn - Removed IP-Checks, added checks for a valid destination
*Rawn - Changed different parts of Rufus to use the eep-proxy, made a config-dialog for the IP/Port for the eep-proxy/SAM and ensured, that the given values are used
*Rawn - Removed the "Referer" future (pretending to be reffered from page x while fetching a torrent file) and all dialogs for it, because I did not figure out, how to implement that future together with using a proxy
*Rawn - Removed the maxport/minport and some IP-binding options from the config-dialogs
*Rawn - Changed the about screen and changed all occurences of "Rufus" to "I2PRufus" (which I found) and some occurences of "IP" to "Destination" or just "Dest"
*Rawn - Prevent the lowering of the destination for the "Peers" column, as that renders it useless for copy/paste
*Rawn - Disabled the searchpanel, because it isn't ported yet, and in my humble opinion currently pointless.
*Rawn - Some other very very small GUI/other changes

0.0.1  - 05.11.05
-----------------------
*Rawn -   fixed a bug  in: DownloaderFeedback.py
	    replaced  the "rec["ip"], rec["port"] = c.get_address()"	with 
   	    rec["ip"] = c.get_address()
   	    rec["port"] = '' 
*defnax - added in SamServer.py  get_address





0.6.5.- Sept 17, 05
-----------------------
* d0c - Added Stop All torrents and Resume All torrents - small down arrow next to Stop and Resume buttons (req by Monk2000)
* d0c - Added download threshold setting to LeoXV choker - how much the peer has to download before choker is activated (req by Monk2000)
* d0c - Added Total Seed, Peer, Leech info to trayicon tooltip popup
* d0c - Added a check for multi-gzip error to zurllib - which was not as much work as I thought (req skee)
* d0c - Added SSL support (with gzip) for trackers - both announce and scrape (req wayno)
* d0c - Added 'tracker URL' to masterlist (req by czesiu)
* d0c - Start/Resume and Pause/Requeue can be configured so that they don't move the torrents around anymore - look in prefs under Peer/Torrent List (req by sid32)
* d0c - Partial rewrite of g3peerid to remove redundant code
* d0c - Reorganised the search panel GUI - more intuitive having all the controls at the top.
* d0c - Fixed an annoyance in search panel settings where you would could fill out the settings and not be able to save them
* d0c - Fixed a few problems with unicode and user interface translation - though there are probably more... (thanks Stefan)
* d0c - Fixed a bug in the peerlist where if torrent paused or stopped the peerlist would unnecessarily continue to try to delete item listings that didn't exist
* d0c - Bug fix in multi-file manager - right-clicking on the checkboxes caused an error
* d0c - Bug fix in Rerequester - when tracker returned bencoded data without peer IP addresses (like a blacklisted port message) an error would occur - error introduced in 0.5.7
* d0c - Bug fix - Rufus now removes all whitespace from torrent announce strings as this would cause errors in scrape
* d0c - Removed *ALL* setdefaulttimeout's as they was causing read errors with SSL

0.6.4 - Sept 8, 05
-----------------------
* d0c - Fixed error in peerlist so that it only auto sorts when selected in peerlist prefs (introduced in version 0.6.0)
* d0c - Fixed error in friends feature when selecting 'Never upload to this peer'
* d0c - More updates to peer identification - New Shareaza peerid and Ktorrent peerid added
* d0c - Fixed a bug in Create torrent (thanks Mr Splenius)
* LeoXV - (Linux) Fixed a bug with GUI update refresh under Linux (merged from Linux 0.6.1)
* LeoXV - Corrected a typo in storage wrapper
* LeoXV - (Linux) Squashed a bug in the clipboard access when adding a torrent via the 'Add from URL' button

0.6.3 - Sept 2, 05
-----------------------
* d0c - Now catching an error in g3rpcserver where if webinterface port was changed it would cause an error on restart
* d0c - Tray Icon graphs now clear when Rufus is restored from tray - requested as it can be misleading as it is not updated when Rufus isn't minimised to tray
* d0c - Fixed bugs in the search panel with the buttons - made some last minute changes and was a little over-confident with my coding I think... not enough testing :)

0.6.2 - Sept 1, 05
-----------------------
* d0c - Completed the activexwrapper for the search panel.  Download requests intercepted so that torrents are loaded directly into Rufus
* d0c - Fixed a small issue with selection of peers from peerlist - clicking on mini-p2pgauge wouldn't select the list item

0.6.1 - Aug 24, 05 - Merge
-----------------------
* Merged the following changes from LeoXV into the current Rufus source:
 * LeoXV - Tweaked socket timeout within scrape - will hopefully speed up Rufus shutdown in win32
 * LeoXV - (Linux) Reduction of CPU usage when minimized
 * LeoXV - Added ability to select more than one torrent at a time when loading torrents (requested)
 * LeoXV - (Linux) Fixed stat errors on shutdown and reduced socket timeout to increase speed of close
 * LeoXV - Added LeoXV's choker - adds share ratio parameter to g3torrent choker
 * LeoXV - Added peer identification for MooPolice, SwarmScope, BTSlave and alt. libTorrent

0.6.0 - Aug 8, 05
-----------------------
* d0c - (win32) Search tab can now be disabled by right-clicking on the tabs and unchecking the 'search' option - eliminating resources used by search panel (restart needed to free resources properly - mijnimise to tray works to an extent)
* d0c - (win32) Added a new settings panel to the search tab which gives the user more control over the search engine settings
* d0c - Fixed a bug in the friends panel where if a non-default web interface/XMLRPC port was used it would disable the friends feature in certain circumstances
* d0c - Fixed an intermittent bug in the XMLRPC server which appeared when when a torrent was loaded directly from a web-browser causing Rufus to start - all other attempts to load more from the browser would fail (thanks odo646)
* d0c - Rufus now remembers the columns settings between torrents (req by R a d)

0.5.9 - July 24, 05
-----------------------
* d0c - Added search tab (win32 only for the moment) to allow for HTML searches to be carried out (requested)
* d0c - Added titlebar branding to the client - allows text to be added to the Rufus titlebar(requested)

0.5.8 - June 9, 05
-----------------------
* d0c - (win32) Finally fixed an annoying problem with the ListCtrl refresh introduced when upgrading to wxpython 2.6
* d0c - Added password protection to tray icon - password stored as MD5 hash in ini (requested)

0.5.7 - May 18, 05
-----------------------
* AlDoogy - Addition of listening port to details panel
* AlDoogy - Added tracker response debug output (config via btconfig.ini - set dbg_tracker to TRUE)
* AlDoogy - Added handling of incorrectly bencoded tracker data
* d0c - Re-added the function to clear the statusbar message when switching to messages tab (req by fadetoblack) 
* d0c - Fixed a bunch of gui bugs in preparation for upgrade to wxpython 2.6 (graph, progress dblclk popup etc.)
* d0c - Added choice of percentage mini-progress bar for peer/torrent list config via prefs (req by back2earth)
* d0c - Added a whole bunch of missing country flags
* d0c - Fixed BitTornado peer identification and added modded FUTB/xUTB BitComet client ident
* d0c - Fixed bug with status panel which was causing problems with sizing the columns
* d0c - Fixed User-Agent reporting - Rufus now correctly identifed by certain trackers

0.5.6 - April 6, 05
-----------------------
NOTE: Main Reason for such a quick update is that the locale directory is missing from the 0.5.5 installer
* d0c - Added the locale directory to the installer (includes English and 'h4x0r' language - for testing purposes)
* d0c - Small fix to flag lookup to deal with uppercase domains

0.5.5 - April 5, 05
-----------------------
* d0c - Fixed the installer so that it reads all 4 torrent incoming/complete folder names
* d0c - Found and converted text that I missed in the internationalisation/language efforts in 0.5.4
* d0c - Changed the Seeds/Peers column to show Seeds/Leechers instead and totals now shows seeds, leechers and peers (req by Preducer and odo646)
* d0c - Added referer option to web interface
* d0c - Fixed a whopping great bug with the web interface (thanks sid32)

0.5.4 - March 29, 05
-----------------------
* d0c - Added update checking on start/every N hours (config in prefs) 
* d0c - Added support for languages/translation of the Rufus GUI.  Needs testing before actual translation of the GUI

0.5.3 - March 28, 05
-----------------------
* LeoXV - Fixed problems with update threading in RSS reader
* d0c & LeoXV - Fixed a bug with the threading used in XMLRPCserver
* d0c - Changed remove routines to only attempt to remove files if they exist - stops annoying 'file not found' error messages
* d0c - Added rescan torrent folder right-click option to torrent list (req sid32)
* d0c - Now catching socket.timeout exception in URLfetch
* d0c - Added referer spoofing to 'add from URL'
* d0c - Added detection of ZipTorrent, Arctic and older version of Azureus to g3peerid as well as 2 unknown clients 'PO' and 'UR' which I've seen a few times
* d0c - RSS reader now waits until return from feed update before allowing another update... prevents multiple requests to the same RSS feed (hammering)
* d0c - Removed 'up' and 'down' status bar text... arrows should be more than enough
* d0c - Re-organised colour preferences - seperate colour choices for taskbar icon now and removed 'requested' (for now)
* d0c - Moved 'popup error messages' prefs option into 'error options' panel (makes more sense)
* d0c - Installer now reads previous torrent/download path from btconfig.ini unless blank and displays them in the installer (req sid32)
* d0c - Changed the default icons... might add a simple icon skinning option so that other icon sets, including the old blue ones, can be used.

0.5.2 - February 28, 05
-----------------------
* d0c - Added detection of BitVampire 1.3.1 and GreedBT 2.70 to g3peerid
* d0c - Updated text in the NSIS installer script to better explain temp torrent folder and removed the popup 'please specify a folder' popup
* d0c - Attempted fix #5 for wx.BufferedDC error ;)
* d0c - Fixed RSS feed save - would sometimes remove entries when nothing was selected
* d0c - Changes in build/package to optimise the bytecode before py2exe processing
* d0c - Fixed 'Resume' function so that it shows hash checking percentage on resume

0.5.1 - February 23, 05
-----------------------
* d0c - Fixed useragent not being announced correctly to trackers
* d0c - Column sorting fixed in status list for Raw Peerid
* d0c - Added detection of Ctorrent to g3peerid
* d0c - Prefs dialog now interacts with taskbar and added linebreaks to WebUI panel and Connections panel (req by solitaryrpr)
* d0c - Changed text in RSS reader to make saving of RSS addresses more apparent and added tooltip
* LeoXV - Experimental 'announce' changes implemented

0.5.0 - February 21, 05
-----------------------
* LeoXV - Tweaks to g3listctrl for Linux Compatibility
* d0c - changes to the installer to check for existing download/torrent folders
* d0c - Squished the OverFlowError bug
* d0c - Added Bits on Wheels and BitLord detection to g3peerid

0.4.9 - February 17, 05
-----------------------
* d0c - Added new eXeem peer_id and name detection
* LeoXV - Fixed Linux resource problems related to an earlier 'bug fix' by d0c ;)
* d0c - Updated the installer to allow the user to select download and torrent folders and to detect other instances of the installer running in memory

0.4.8 - February 13, 05
-----------------------
* d0c - Popped that balloon (the popup balloon that I actually broke a few versions back that no-one will miss ;))
* d0c - Small changes to the way the seeds/peers/downloaded stats are scraped from the tracker (this will not alter download performance ;) )
* d0c - Other small bug fixes
* d0c - Added detection of BTGetit peerid
* LeoXV - Squashed Linux scrollbar bug
* LeoXV - Fixed Linux incompatibility in double-click progress dialog
* LeoXV - Upgraded Linux version to support wxpython 2.5

0.4.7 - February 9, 05
-----------------------
* d0c - Having issues with Python 2.4 and 'OverflowError' errors.  Client back to Python 2.3.4 for now.  
* d0c - Fixed issue with draging and dropping of torrents - decode errors when torrents were OK

0.4.6 - January 31, 05
-----------------------
* d0c - Fixed installer to correct an error with paths

0.4.5 - January 28, 05
-----------------------
* LeoXV - Fixed bug with Friends/Foe dropdown box
* d0c - Rewrote RSS reader to use threads to avoid blocking by the feedparser
* d0c - Added Auto piece size option to the 'make torrent' function
* d0c - Catching 'BadStatusLine' error in both Scrape and Announce functions now

0.4.0 - January 17, 05
-----------------------
* d0c - Added code to allow RSS feeds to be saved
* d0c - Added a proper HTML preview window to RSS reader
* d0c - Fixed an error with the displaying of non-English characters in the RSS Reader
* LeoXV - Added peer/seed totals to status bar
* LeoXV - Added date to message timestamp
* d0c - Added/Fixed Asian language support - tested with both Japanese and Chinese
* d0c - Added utf-8 encoding support to 'make torrent' option - compliant with current Azureus and BitComet .utf-8 extension

0.3.2 - January 12, 05
----------------------
* d0c - Added code to reset colours to default in prefs
* d0c - Updated the Unicode support to support the utf-8 extension and different types of encoding via 'encoding' entry
* d0c - Added a 'Stopped' message to the p2pgauge when a torrent is stopped
* d0c - Added the &no_peerid=1 flag to the announce string for tracker comptability
* d0c - Fixed the error where there are two alternating torrent states for the same torrent

0.3.1 - December 17, 04
-----------------------
* d0c - Fixed the double-click on torrent error where the progress dialog would only be displayed once (req by aretecte)
* d0c - Fixed an issue with the time not being displayed in the torrent progress dialog (req by sid32)
* Bones - Added toggle toolbar function/menu option (req by aretecte)
* Bones - Added toggle tabs button on toolbar (req by aretecte)
* Apraxhren - Fixed a bug in progress dialog where colours were displayed incorrectly
* d0c - Removed leech choker and spoof abilities - sharing good... leeching bad.  Spoofing unnecessary.
* d0c - Added right-click remove/add pages from the tab window (Details, Graph, Messages... etc) 
* d0c - Added peerid recognition for all versions of: eXeem, Shareaza, XBT, XanTorrent, BitSpirit, BitComet, Burst!, Experimental, TurboBT, TorrentTopia, BitBuddy, TorrenTres and re-wrote detection for Mainline
* d0c - Created a new peerid for BitMagnet which includes the version number

0.3.0 - October 31, 04
----------------------
* Now based on G3torrent RC1
* Upgraded g3 to support wxpython 2.5.2.8u (g3rmz was responsible for the bulk of this)
* Fixed the RSS reader (no more ASCII decode errors)
* Changed spoofing to include useragent string - making it much harder for trackers to block g3
* Added a select checkbox function to the right-click in the multi-file manager
* Fixed g3 RC1 double click error which was only seen when a double clicking on a .torrent while g3 RC1 wasn't open
* Fixed an error where when you double clicked on a .torrent file it wasn't being loaded into g3 - this was due to an error in my code with my first two tweaked versions (surprised it wasn't reported as a bug...)
* Rewrote the Web Interface POST function so that when you change the Web Interface port double clicking on a .torrent still works
* Unicode support upgraded meaning much greater support for other languages (still working on Asian support - this is a tough one)
* Added DNS lookup to the friends list (experimental) editing the friends.ini and replace the ip address with no-ip etc hostname if I get enough requests I will change the interface to accept both IP addresses and dynamic hostnames (no-ip.com etc)
* Fixed the installer so that it removes the g3 desktop icon and g3 start menu shortcuts correctly.

0.2.0 - October 2, 04 
--------------------- 
* Recoded the web interface to use POST method so no password etc shown in URL (req by ricochet_sf) 
* Added an extra refresh button at the top of the web interface (Req by mochaaddict24) 
* Added unicode language support using CJKPython - support for Asian languages etc (req by kanji_man) 
* Added a setting in 'General settings' that lets you have a fixed tray icon (no disappearing) (req by sid32) 
* Fixed the 'associate' button so it shouldn't break the .torrent file association 

0.1.0 - September 19, 04 
------------------------ 
* Added 'select all' to right-click in multifile manager 
* Added 'invert selection' to right-click in multifile manager (requested on the boards) 
* Added the ability to change the port of the Web Interface (from default 7007) (requested) 
* Added option to not restore G3 from taskbar when adding torrent via web interface 
* Added 'browse to torrent data folder' right-click option in the torrent window 
* Added 'browse to default incoming folder' button in toolbar 
* Added ability to copy the torrent info hash to the clipboard by clicking on it 
* Corrected a bug where when a multi-folder torrent was deleted it left behind folders 
* Corrected bug where G3 moved the wrong folder on completion of multi-file torrents if non-default save was selected and move to folder was set in prefs. 

